#2
def suite(n,u = [1]):
    #n est la n-ième ligne de la suite à afficher
    #la fonction affiche les n premières ligne de la suite

    if n > 0:
        v=[]
        j = 1
        print(u)
        for i in range(len(u)):
            if i != len(u) -1:
                if u[i] == u[i+1]:
                    j+=1
                else:
                    v.append(j)
                    v.append(u[i])
                    j=1
            else:
                v.append(j)
                v.append(u[i])
        suite(n-1, v)

from math import *

#3
def estmagique(carre):
    #carre est une liste de listes et réprésente le carré
    #la fonction renvoie True si le carré est magique, False sinon
    cote = len(carre)
    somme = (cote * 2 + 2)*[0]
    for i in range(cote):
        for j in range(cote):
            somme[2*j]+=carre[i][j]
            somme[2*j+1]+=carre[j][i]
        somme[-1]+= carre[i][i]
        somme[-2]+=carre[i-cote][i]
    
    magique = True

    for i in range(len(somme)-1):
        if(somme[i]!=somme[i+1]):
            magique=False
            break
    return magique

#4
def frequenceletre(chaine):
    #chaine est la chaine de caracteres à analyser
    #la fonction renvoie la fréquence d'apparition des lettres de l'alphabet
    #dans la chaine

    n = 26*[0]
    taille = len(chaine)
    m = 26*[0]
    for i in range(taille):
        lettre = ord(chaine[i])
        if (lettre >= 97 and lettre < 123):
            n[lettre%97]+=1
        elif(lettre >= 65 and lettre < 91):
            n[lettre%65]+=1
        
    for i in range(len(n)):
        m[i] = round((n[i]/ taille) * 100, 1)
    return m

from random import *

#5
def de(n):
    #renvoie la valeur d'un lancer de dé à n faces
    return int(random()*(n)+1)

def detruque():
    #la fonction renvoie la valeur du dé truqué
    if de(2) == 2:
        return 6
    else:
        return de(5)


#6

#le graphe est de la forme : [nb de sommet, [listes des arretes]]
#une est arrete de la forme : [sommetA, sommetB]

#2)
def listevoisins(graphe, s):
    #graphe est le graphe à utiliser, s est l'indice du sommet dont on veut
    #connaitre la liste des voisins donnée par la fonction
    nbarrete = len(graphe[1])
    lvoisin = []
    for i in range(nbarrete):
        for j in range(2):
            if(graphe[1][i][j] == s):
                lvoisin.append(graphe[1][i][1-j])
    return lvoisin

#3)
def sommetisole(graphe, s):
    #graphe est le graphe à utiliser, s est l'indice du sommet
    #La fonction renvoie True si le sommet est isolé, False sinon
    if len(listevoisins(graphe, s)):
        return False
    return True

#4)
def sontvoisins(graphe, s):
    #graphe est le graphe à utiliser, s est une liste de 2 sommets
    #la fonction renvoie True si les 2 sommets sont voisins False sinon
    nbarrete = len(graphe[1])
    s1 = [s[1],s[0]]
    for i in range(nbarrete):
        if(s == graphe[1][i] or s1 == graphe[1][i]):
            return True

    return False


def parcourspossible(graphe, p):
    #graphe est le graphe à utiliser, p est une liste contenant les sommets
    #du parcours. La fonction renvoie True si le parcours est possible, False sinon
    if(len(p)>1):
        if(sontvoisins(graphe, [p[0],p[1]])):
            return parcourspossible(graphe, p[1:len(p)])
        else:
            return False
    else:
        return True

#5)
def isparcours(graphe, p):
    #graphe est le graphe à utiliser, p est une liste contenant
    # l'indice des 2 sommets dont on veut savoir si il existe un parcours
    #entre les 2 par la fonction

    l = listevoisins(graphe,p[0])
    parcours = False

    if(sontvoisins(graphe, p) or p[0] == p[1]):
        return True

    newgraph = [graphe[0],[]]

    for i in range(len(graphe[1])):
        if(graphe[1][i][0] != p[0] and graphe[1][i][1] != p[0]):
            newgraph[1].append(graphe[1][i])

    for e in l:
        parcours = isparcours(newgraph, [e, p[1]])
        if parcours:
            break
    
    return parcours
